# Generated by generate_sdk_wrappers.py. DO NOT EDIT

from abc import ABCMeta
from dataclasses import dataclass, field
from typing import Any, Optional
from uuid import uuid4

from luminarycloud.tables import RectilinearTable
from luminarycloud.types import Vector3
from luminarycloud._proto.client import simulation_pb2 as clientpb
from luminarycloud._proto.client.entity_pb2 import EntityIdentifier
import luminarycloud.params.enum._enum_wrappers as enum

from ._lib import ParamGroupWrapper, create_unique_id

from .particle_group_type import ParticleGroupType
from .actuator_disk_orientation_selection import ActuatorDiskOrientationSelection
from .actuator_disk_specify_normal_vector import ActuatorDiskSpecifyNormalVector
from .actuator_disk_specify_rotation_angles import ActuatorDiskSpecifyRotationAngles


@dataclass(kw_only=True)
class ActuatorDisk(ParticleGroupType):
    """Applies a uniform force at all locations on the disk"""

    inner_radius: float = 0.0
    "The inner radius of the actuator disk"
    outer_radius: float = 1.0
    "The outer radius of the actuator disk"
    center: Vector3 = field(default_factory=lambda: Vector3(0.0, 0.0, 0.0))
    "Hub location (x,y,z) for rotor/propeller"
    actuator_disk_orientation_selection: ActuatorDiskOrientationSelection = field(
        default_factory=ActuatorDiskSpecifyRotationAngles
    )
    "Specify orientation via normal vector, or a series of x-, y-, z-rotational transformations"
