# Generated by generate_sdk_wrappers.py. DO NOT EDIT

from abc import ABCMeta
from dataclasses import dataclass, field
from typing import Any, Optional
from uuid import uuid4

from luminarycloud.tables import RectilinearTable
from luminarycloud.types import Vector3
from luminarycloud._proto.client import simulation_pb2 as clientpb
from luminarycloud._proto.client.entity_pb2 import EntityIdentifier
import luminarycloud.params.enum._enum_wrappers as enum

from ._lib import ParamGroupWrapper, create_unique_id

from .outlet_strategy import OutletStrategy


@dataclass(kw_only=True)
class OutletTargetCorrectedMassFlowRate(OutletStrategy):
    """Specify a target mass flow rate corrected for given reference temperature and pressure (&#856;m<sub>corr</sub> = &#856;m <sup>&radic; T<sub>0</sub></sup> &frasl; <sub>&radic;T<sub>ref</sub></sub> <sup>P<sub>ref</sub></sup> &frasl; <sub>P<sub>0</sub></sub>)."""

    pressure: float = 101325.0
    "Static pressure at the boundary relative to the material reference pressure. Also used as initial estimate to establish the target mass flow rate if requested."
    target_mass_flow_rate: float = 1.0
    "Target mass flow rate (or corrected mass flow rate)."
    reference_pressure: float = 101325.0
    "Absolute total pressure used to compute the corrected mass flow target."
    reference_temperature: float = 288.15
    "Total temperature used to compute the corrected mass flow target."
