# Generated by generate_sdk_wrappers.py. DO NOT EDIT

from abc import ABCMeta
from dataclasses import dataclass, field
from typing import Any, Optional
from uuid import uuid4

from luminarycloud.tables import RectilinearTable
from luminarycloud.types import Vector3
from luminarycloud._proto.client import simulation_pb2 as clientpb
from luminarycloud._proto.client.entity_pb2 import EntityIdentifier
import luminarycloud.params.enum._enum_wrappers as enum

from ._lib import ParamGroupWrapper, create_unique_id

from .convective_scheme_order import ConvectiveSchemeOrder


@dataclass(kw_only=True)
class SecondOrder(ConvectiveSchemeOrder):
    """Second-order accuracy."""

    robust_dissipation: enum.RobustDissipation = enum.RobustDissipation.ROBUST_DISS_OFF
    "Use a form of dissipation that improves robustness but that may reduce accuracy."
    limiter: enum.Limiter = enum.Limiter.NO_LIMITER
    "Apply a slope limiter for second-order upwind schemes. This tends to increase robustness at the expense of solution time and higher dissipation in regions of the flow with sharp gradients. For this reason, it may be helpful to increase gradient blending parameters when using limiters."
    limiter_kappa: float = 0.1
    "Parameter defining smooth flow regions where the limiter is disabled, and also where less robust dissipation is applied (if enabled). Higher values reduce limiting and/or dissipation."
    umuscl_chi: float = 0.0
    "Chi parameter of the U-MUSCL variable extrapolation scheme in (-1,1)."
    alpha_ld2: float = 0.0
    "Parameter in range [0,1], generally 0 is more robust and 1 more accurate, thus it should be used on high quality grids with gentle stretching. On uniform meshes 0 gives a 2nd order reconstruction, and 2/3 gives a 4th order reconstruction. With the value 1, 2nd order is also obtained on non uniform meshes."
    geometry_fixes: enum.GeometryFixes = enum.GeometryFixes.GEOMETRY_FIXES_ON
    "Strategies to cope with problematic mesh regions (e.g. high skewness angles)."
    geometry_fixes_mitigations: float = 0.25
    "Magnitude of the geometrical fixes mitigations. Expected value within [0,1]. The higher this value, the more numerical dissipation is added at control volumes with low-quality topological properties."
    order_blend: float = 1.0
    "Blend factor in [0,1] between a first-order and second-order convective scheme. A value of 0 results in a first-order scheme, and a value of 1.0 results in a second-order scheme. 1.0 by default. A value less than 1.0 may improve robustness at the cost of accuracy compared to a pure second-order scheme."
